package listFW;
import fp.*;
import java.util.*;

/**
 * Represents the abstract list structure.
 */
public interface IList {
  
  /**
   * Filter the list, returning a new list with only the elements 
   * that are "less than" the given Object x, as determined by the 
   * given Comparator, i.e. returns -1 for comp.compare(_first, x).
   */
  public IList filter(Comparator comp, Object x);
  
  
  /**
   * Folds (right) the given lambda over the list, returning the resultant value. 
   * This is the invariant part of the reverse accumulation process.
   */
  public abstract Object foldr(ILambda lambda, Object base);
  
  /**
   * Helper method for toString()
   */
  public String toString_Help(String acc);
}
