package listFW;
import fp.*;
import java.util.*;

/**
 * Represents non-empty lists.
 */
public class NEList implements IList {
  private Object _first;
  private IList _rest;
  
  public NEList(Object f, IList r) {
    _first = f;
    _rest = r;
  }
  
  /**
   * Includes current element along with the rest of the filtered list
   * if the current element is "less than" the given Object x, as 
   * determined by the given Comparator.
   */
  public IList filter(Comparator comp, Object x) {
    // Part b) STUDENT TO COMPLETE (10 pts)
    // A skeleton of the comparison test has been provided.
    // Add code anywhere you feel is necessary.
    // You are not required to use the if-else code.
    
    
    if(comp.compare(_first, x) < 0) {
      // "Passes" compare test, include current element in the result. 
      return new NEList(_first, _rest.filter(comp, x));
    }
    else {
      // "Fails" compare test, do not include current element in result
      return _rest.filter(comp, x);
    }
    
    // Alternative one-line solution    
    // return (comp.compare(_first, x) < 0) ? new NEList(_first, _rest.filter(comp, x)) : _rest.filter(comp, x); 
  }
  
  /**
   * Folding right over a non-empty list returns the application of the lambda 
   * to the first element and the recursive result.
   */
  public Object foldr(ILambda lambda, Object base) {
    // Part d) STUDENT TO COMPLETE (15 pts)
    return lambda.apply(_first, _rest.foldr(lambda, base));
  }
  
  public String toString() {
    return _rest.toString_Help("("+_first);
  }
  public String toString_Help(String acc) {
    return _rest.toString_Help(acc+", "+_first);
  }
  
  
}
