package listFW.test;

import junit.framework.TestCase;
import listFW.*;
import fp.*;
import java.util.*;


public class Test_IList extends TestCase {
  
  
  public void test_filter() {
    Comparator comp = new GreaterThanComparator();
    
    IList aList = MTList.Singleton;
    int compVal = 7;
    
    assertEquals("MT, comp = >, 7", "()", aList.filter(comp, compVal).toString());
    aList = new NEList(5, aList);
    assertEquals("(5), comp = >, 7", "()", aList.filter(comp, compVal).toString());
    aList = new NEList(15, aList);
    assertEquals("(15, 5), comp = >, 7", "(15)", aList.filter(comp, compVal).toString());
    aList = new NEList(7, aList);
    assertEquals("(7, 15, 5), comp = >, 7", "(15)", aList.filter(comp, compVal).toString());
    aList = new NEList(20, aList);
    assertEquals("(20, 7, 15, 5), comp = >, 7", "(20, 15)", aList.filter(comp, compVal).toString());
    
    comp = new LessThanComparator();
    assertEquals("(20, 7, 15, 5), comp = >, 7", "(5)", aList.filter(comp, compVal).toString());
    
  }
  
  public void test_foldr() {
    IList aList = MTList.Singleton;
    
    ILambda lambda = new Product();
    
    assertEquals("MT, product", 1, aList.foldr(lambda, 1));
    aList = new NEList(10, aList);
    assertEquals("(10), product", 10, aList.foldr(lambda, 1));
    aList = new NEList(-1, aList);
    assertEquals("(-1, 10), product", -10, aList.foldr(lambda, 1));
    aList = new NEList(2, aList);
    assertEquals("(2, -1, 10), product", -20, aList.foldr(lambda, 1));

    lambda = new ToString();             
    assertEquals("(2, -1, 10), product", "2 -1 10 !!", aList.foldr(lambda, "!!"));
    
  }
  
}
